/*
 * Grundkurs Informatik - Beispielprogramm zur LZW-Datenkompression
 * J. Schmidt, 2016
*/

#ifndef LZW
#define LZW

#include "bytekette.h"

// ein einzelner Eintrag der Codetabelle
typedef struct
{
	t_byte_kette zeichen; // ein Eintrag kann aus mehreren Zeichen bestehen -> Array
	unsigned int code;    // zugewiesener Code
} t_eintrag_codetabelle;

// gesamte Codetabelle
typedef struct
{
	t_eintrag_codetabelle *tabelle;
	unsigned int maxAnzEintraege;  // Größe des Arrays tabelle[]
	unsigned int anzEintraege;     // aktuell verwendete Anzahl Einträge in der Tabelle
	unsigned int anzBitCode;       // Anzahl Bit pro Codewort
} t_Codetabelle;

// Daten für Ausgabecode
typedef struct
{
	unsigned int anzBitCode;       // Anzahl Bit pro Codewort
	size_t anzCodewoerter;         // tatsächlich verwendete Anzahl Codewörter
	size_t maxAnzCodewoerter;          // Größe des aktuell reservierten Speicherplatzes  (Größe der Arrays)
	unsigned int *ausgabe_ui;      // jedes Codewort getrennt als ui gespeichert
	unsigned int *ausgabe_kompakt; // Codewörter unter Verwendung von anzBitCode Bit kompakt gespeichert
	size_t speicherBlockGroesse;  // Blockgröße, in denen Speicherplatz alloziert wird
} t_Ausgabe;

#endif
